        PAGE 72,120
        TITLE Asmdemo3  -  udskriv p skrmen direkte i buffer med procdurer
;-----------------------------------------------------------------------------
;       Bjrk Busch   2/5-1990          Eksempel p EXE program.
;-----------------------------------------------------------------------------

Cseg    Segment Para Public 'CODE'

        Assume Cs:Cseg,Ds:Dseg,Es:nothing,Ss:Sseg
;-----------------------------------------------------------------------------
;       Hovedrutine
;-----------------------------------------------------------------------------
Main    Proc    Near

        Mov     Ax,Seg Dseg             ; etabler
        Mov     Ds,Ax                   ;     datasegment
        
        Call    Clear

        Mov     Es,SkrmSeg
        XOR     Di,Di                   ; Es:Di -> start p skrmbuffer
        Mov     Si,Offset Txt1          ; Ds:Si -> tekst som skal udskrives 
        Mov     Bx,Offset Txt1end       ; Bx -> slutadresse (offset)
        Mov     Ah,Attrib               ; Ah := attribute
        Call    Skriv

        Call    Curs20

        Mov     Al,0                    ; returkode = 0
        Mov     Ah,TermPro              ; opst funktion for
        Int     DosServ                 ; terminate og udfr

Main    EndP
;-----------------------------------------------------------------------------
;       Slut p Hovedrutine
;-----------------------------------------------------------------------------

Clear   Proc    Near
;------------------------------------------------------------------------
; Proceduren anvendes til blanke skrmen
; Rutinen anvender flgende registre som arbejdsregistre
;       Ax,Dx   som gemmes og restores ved afslutning
;------------------------------------------------------------------------ 
        Push    Ax                      ; save arbejds-
        Push    Dx                      ;     registre
        Mov     Dx,offset ClrScr        ; DS:DX -> ClrScr (ansi-esc.sekv.)
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 
        Pop     Dx                      ; restore arbejds-
        Pop     Ax                      ;     registre
        Ret                             ; returner
Clear   EndP

Curs20 Proc    Near
;------------------------------------------------------------------------
; Proceduren flytte cursoren 20 linie ned
; Rutinen anvender flgende registre som arbejdsregistre
;       Ax,Dx   som gemmes og restores ved afslutning
;------------------------------------------------------------------------ 
        Push    Ax                      ; save arbejds-
        Push    Dx                      ;     registre
        Mov     Dx,offset flytcur       ; DS:DX -> flytcur
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 
        Pop     Dx                      ; restore arbejds-
        Pop     Ax                      ;     registre
        Ret                             ; returner
Curs20  EndP

Skriv   Proc    Near
;------------------------------------------------------------------------
; Proceduren anvendes til at udskrive en tekst direkte i buffer
; Flgende parametre overgives
;       Ds:Si   skal indeholde startadresse p tekst
;       Ds:Bx   skal indeholde adresse p frste byte efter tekst
;       Es:Di   start skrmadresse for frste tegn
;       Al      skal indeholde attribute
; Flgende returneres
;       Es:Di   indeholder ved retur nste skrmadresse
;       Ds:Si   stopadresse (samme som DS:Bx)
; Rutinen anvender flgende registre som arbejdsregistre
;       Ah      som gemmes og restores ved afslutning
;------------------------------------------------------------------------ 
        Push    Ax                      ; save arbejds-register
While:  Cmp     Si,Bx                   ; while 
        Je      EndWhile                ;   Si <> Bx  (flere tegn i tekst)
        Mov     Al,Ds:[Si]              ; Al := ascii-tegn
        Mov     Es:[Di],Ax              ; flyt tegn+attribute til skrmbuffer
        Inc     Di                      ; tl skrmadresse
        Inc     Di                      ;   op til nste tegn
        Inc     Si                      ; Ds:Cx -> nste ascci tegn
        Jmp     While
EndWhile:
        Pop     Ax                      ; restore arbejdsregister
        Ret                             ; returner
Skriv   EndP

;-----------------------------------------------------------------------------
Cseg    EndS                            ; slut p code-segment


Dseg    Segment Para Public 'DATA'
;-----------------------------------------------------------------------------
;       Data definitioner m.m.
;-----------------------------------------------------------------------------
DosServ Equ     21H                     ; dos service interupt
WrtStr  Equ     9H                      ; dos write streng DS:DX p skrm
TermPro Equ     4CH                     ; dos terminate
CR      Equ     13
NL      Equ     10

ClrScr  Db      27,'[2J$'               ; ansi-escape sekv. for blank skrm
SkrmSeg Dw      0B800H                  ; B000h for monokrom (IBM)
                                        ; B800h for color (IBM)
                                        ; F000h for siemens PCD
attrib  Db      7H                      ;normal skrift

txt1    Db      'Dette er tekst  skrevet direkte i buffern'
txt1end Db      ?

flytcur Db      27,'[20B$'
;-----------------------------------------------------------------------------
Dseg    EndS                            ; slut p data-segment


Sseg    Segment Para Stack 'STACK'
;-----------------------------------------------------------------------------
;       Stack
;-----------------------------------------------------------------------------
        dw      128 dup(?)              ; der er sat 128 ord af til stack
;-----------------------------------------------------------------------------
Sseg    EndS                            ; slut p stack-segment

        End     Main                    ; Slut og opst startadresse
