WrtBuf  Macro   P1,P2                   ; kaldes med buffer offset
                                        ; eks. 1  WrtBufO offset uddata
                                        ;      2  WrtBufO Di
                                        ; buffer skal slutte med $-tegn
        PushF                           ; gem flag og
        Push    Dx                      ;    arbejdsreg.
        Push    Ax
        Mov     Dx,P1 P2                ; DS:DX -> buffer
        Mov     Ah,09H                  ; opst funktion for udskrift
        Int     21H                     ; af streng og udfr
        Pop     Ax
        Pop     Dx                      ; restore arbejdsreg. og 
        PopF                            ;    flag
        EndM

WrtChr  Macro   P1                      ; kaldes med tegn
        PushF                           ; gem flag og
        Push    Dx                      ;    arbejdsreg.
        Push    Ax
        Mov     Dl,P1                   ; Dl := tegn
        Mov     Ah,06H                  ; opst funktion for udskrift
        Int     21H                     ; af streng og udfr
        Pop     Ax
        Pop     Dx                      ; restore arbejdsreg. og 
        PopF                            ;    flag
        EndM

RdBuf   Macro   P1,P2                   ; kaldes med buffer offset
                                        ; eks. 1  RdBuf offset indata
                                        ;      2  RdBuf Di
                                        ; Buffer besk:
                                        ;     pos 1-1  lngde af buffer
                                        ;     pos 2-2  antal tegn indlst
                                        ;     pos 3-?  data
        PushF                           ; gem flag og
        Push    Dx                      ;    arbejdsreg.
        Push    Ax
        Mov     Dx,P1 P2                ; DS:DX -> buffer
        Mov     Ah,0AH                  ; opst funktion for indls
        Int     21H                     ; af streng og udfr
        Pop     Ax
        Pop     Dx                      ; restore arbejdsreg. og 
        PopF                            ;    flag
        EndM

TermPro Macro   P1                      ; parameter evt. returkode
        IFB     <&P1>                   ; hvis ingen returkode
        Mov     Al,0                    ; returkode = 0
        ELSE
        Mov     Al,P1                   ; returkode = P1
        ENDIF
        Mov     Ah,4CH                  ; opst funktion og
        Int     21H                     ; terminate
        EndM
