        PAGE 72,120
        TITLE AsmCom  -  eksempel p COM-program
;-----------------------------------------------------------------------------
;       Bjrk Busch   2/5-1990
;
;       Princip:
;           a)  KUN et segment
;           b)  100h byte til PSP i start af segment
;               Frste instruktion skal vre i adresse 100h
;           c)  Stak optager resterende af 64 KB som segment optager
;           d)  DOS stter AUTOMATISK Cs, Ds og SS til start p segment,
;               Ip til 100h og SP til FFFE - idet der ligger en
;               returadresse til 0000 sidst p stakken, sledes at
;               programet i princippet kan slutte i main procedure
;               med en RET instruktion, da DOS her har indlagt en
;               termineringsinstruktion.
;
;       NB !!!  Oversat modul SKAL kres gennem EXE2BIN fr krsel
;-----------------------------------------------------------------------------
Cseg    Segment Para

        Assume Cs:Cseg,Ds:Cseg,Es:nothing,Ss:Cseg

        ORG     100h                    ; afst plads til PSP - skal vre her

;-----------------------------------------------------------------------------
;       Hovedrutine
;-----------------------------------------------------------------------------
Main    Proc    Near

        Mov     Dx,Offset Tekst1        ; DS:DX -> tekst1
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 

        Mov     Dx,Offset Tekst2        ; DS:DX -> tekst2
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 

        Mov     Al,0                    ; returkode = 0         ( kan erstat-)
        Mov     Ah,TermPro              ; opst funktion for    ( tes af     )
        Int     DosServ                 ; terminate og udfr    ( RET        )

Main    EndP

;-----------------------------------------------------------------------------
;       Data definitioner m.m.
;-----------------------------------------------------------------------------
DosServ Equ     21H                     ; dos service interupt
WrtStr  Equ     9H                      ; dos write streng DS:DX p skrm
TermPro Equ     4CH                     ; dos terminate
CR      Equ     13                      ; carrige return
NL      Equ     10                      ; new line

Tekst1  Db      'Dette er tekst1 fra assemblerprogramet',CR,NL,'$'
Tekst2  Db      'Denne er endnu en lille tekst som ogs er '
        Db      'fra assemblerprogrammet',CR,NL,'$'

;-----------------------------------------------------------------------------
Cseg    EndS                            ; slut p segment

        End     Main                    ; Slut og opst startadresse
