        PAGE 90,120
        TITLE Asmdemo2  -  udskriv en tekst p skrmen direkte i skrm-buffer
;-----------------------------------------------------------------------------
;       Bjrk Busch   2/5-1990          Eksempel p EXE program.
;-----------------------------------------------------------------------------

Cseg    Segment Para Public 'CODE'

        Assume Cs:Cseg,Ds:Dseg,Es:nothing,Ss:Sseg
;-----------------------------------------------------------------------------
;       Hovedrutine
;-----------------------------------------------------------------------------
Start:
        Mov     Ax,Seg Dseg             ; etabler
        Mov     Ds,Ax                   ;     datasegment
        
        Mov     Dx,Offset ClrScr        ; DS:DX -> ClrScr (ansi-esc.sekv.)
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 

        Mov     Es,SkrmSeg              ; opst Es som pegepind til skrmbuf.
        XOR     Di,Di                   ; Es:Di -> start p skrmbuffer
        Mov     Si,Offset Txt1          ; Ds:Si -> tekst som skal udskrives 
        Mov     Bx,Offset Txt1end       ; Bx -> slutadresse (offset)

        Mov     Ah,Attrib               ; Ah := attribute
        
While:  Cmp     Si,Bx                   ; while 
        Je      EndWhile                ;   Si <> Bx  (flere tegn i tekst)
        Mov     Al,Ds:[Si]              ; Al := ascii-tegn
        Mov     Es:[Di],Ax              ; flyt tegn+attribute til skrmbuffer
        Inc     Di                      ; tl skrmadresse
        Inc     Di                      ;   op til nste tegn
        Inc     Si                      ; Ds:Si -> nste ascci tegn
        Jmp     While
EndWhile:

        Mov     Dx,Offset Flytcur       ; DS:DX -> flytcur
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 

        Mov     Al,0                    ; returkode = 0
        Mov     Ah,TermPro              ; opst funktion for
        Int     DosServ                 ; terminate og udfr
;-----------------------------------------------------------------------------
Cseg    EndS                            ; slut p code-segment

Dseg    Segment Para Public 'DATA'
;-----------------------------------------------------------------------------
;       Data definitioner m.m.
;-----------------------------------------------------------------------------
DosServ Equ     21H                     ; dos service interupt
WrtStr  Equ     9H                      ; dos write streng DS:DX p skrm
TermPro Equ     4CH                     ; dos terminate
CR      Equ     13
NL      Equ     10

ClrScr  Db      27,'[2J$'               ; ansi-escape sekv. for blank skrm
SkrmSeg Dw      0B800H                  ; B000h for monokrom (IBM)
                                        ; B800h for color (IBM)
                                        ; F000h for siemens PCD
Attrib  Db      7H                      ;normal skrift

Txt1    Db      'Dette er tekst  skrevet direkte i buffern'
Txt1end Db      ?

Flytcur Db      27,'[20B$'
;-----------------------------------------------------------------------------
Dseg    EndS                            ; slut p data-segment


Sseg    Segment Para Stack 'STACK'
;-----------------------------------------------------------------------------
;       Stack
;-----------------------------------------------------------------------------
        dw      128 dup(?)              ; der er sat 128 ord af til stack
;-----------------------------------------------------------------------------
Sseg    EndS                            ; slut p stack-segment

        End     Start                   ; Slut og opst startadresse
