        PAGE 90,120
        TITLE AsmMain  -  Eksempel p asm.prog. med ekstrene moduler
;-----------------------------------------------------------------------------
;       Eksempel p asm.prog. med ekstrene moduler
;       Bjrk Busch   31/5-1990
;
;       Husk at medtage objectmoduler for underprogrammerne med ved LINK.
;-----------------------------------------------------------------------------

PSPseg  Segment Para COMMON
;-----------------------------------------------------------------------------
;       PSP-segment     skal ligge frst i program
;-----------------------------------------------------------------------------
PSP     Db      100h dup (?)            ; definer PSP
PSPseg  EndS                            ; slut p segment


Cseg    Segment Para Public 'CODE'
;-----------------------------------------------------------------------------
;       Codesegment
;-----------------------------------------------------------------------------

        Assume Cs:Cseg,Ds:Dseg,Es:nothing,Ss:Sseg  ; fortl overstter
                                                   ; hvorfra offset skal
                                                   ; beregnes
        Extrn   SubNear:Near
        Extrn   SubFar:Far
        Extrn   SubN2:Near

;-----------------------------------------------------------------------------
;       Hovedrutine
;-----------------------------------------------------------------------------
Main    Proc    Near

        Mov     Ax,Dseg                 ; etabler
        Mov     Ds,Ax                   ;      datasegment

        Mov     Dx,Offset Tekst1
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 

        Call    SubNear                 ; udfr selvstndig NEAR rutine
        Call    SubFar                  ; udfr selvstndig FAR rutine
        Call    SubN2                   ; udfr selvstndig NEAR rutine

        Mov     Dx,Offset Tekst2
        Mov     Ah,WrtStr               ; opst funktion for udskrift
        Int     DosServ                 ; af streng og udfr 

        Mov     Al,0                    ; returkode = 0
        Mov     Ah,TermPro              ; opst funktion for
        Int     DosServ                 ; terminate og udfr

Main    EndP
;-----------------------------------------------------------------------------
Cseg    EndS                            ; slut p code-segment


Dseg    Segment Para Public 'DATA'
;-----------------------------------------------------------------------------
;       Data definitioner m.m.
;-----------------------------------------------------------------------------
DosServ equ     21H                     ; dos service interupt
WrtStr  equ     9H                      ; dos write streng DS:DX p skrm
TermPro equ     4CH                     ; dos terminate
CR      equ     13                      ; carrige return
NL      equ     10                      ; new line

Tekst1  db      'Fr kald af underprogrammer',CR,NL,'$'
Tekst2  db      'Tilbage i hovedprogram',CR,NL,'$'
;-----------------------------------------------------------------------------
Dseg    EndS                            ; slut p data-segment


Sseg    Segment Para Stack 'STACK'
;-----------------------------------------------------------------------------
;       Stack
;-----------------------------------------------------------------------------
        dw      25  dup(?)              ; der er sat 25 ord af til stack
;-----------------------------------------------------------------------------
Sseg    EndS                            ; slut p stack-segment

        End     Main                    ; opst startadresse
